"""
    MX Platform API

    The MX Platform API is a powerful, fully-featured API designed to make aggregating and enhancing financial data easy and reliable. It can seamlessly connect your app or website to tens of thousands of financial institutions.  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from mx_platform_python.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from mx_platform_python.exceptions import ApiAttributeError



class ManagedAccountUpdateRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'account_number': (str,),  # noqa: E501
            'apr': (float,),  # noqa: E501
            'apy': (float,),  # noqa: E501
            'available_balance': (float,),  # noqa: E501
            'available_credit': (float,),  # noqa: E501
            'balance': (float,),  # noqa: E501
            'cash_surrender_value': (float,),  # noqa: E501
            'credit_limit': (float,),  # noqa: E501
            'currency_code': (str,),  # noqa: E501
            'day_payment_is_due': (int,),  # noqa: E501
            'death_benefit': (int,),  # noqa: E501
            'id': (str,),  # noqa: E501
            'interest_rate': (float,),  # noqa: E501
            'is_closed': (bool,),  # noqa: E501
            'is_hidden': (bool,),  # noqa: E501
            'last_payment': (float,),  # noqa: E501
            'last_payment_at': (str,),  # noqa: E501
            'loan_amount': (float,),  # noqa: E501
            'matures_on': (str,),  # noqa: E501
            'metadata': (str,),  # noqa: E501
            'minimum_balance': (float,),  # noqa: E501
            'minimum_payment': (float,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'nickname': (str,),  # noqa: E501
            'original_balance': (float,),  # noqa: E501
            'payment_due_at': (str,),  # noqa: E501
            'payoff_balance': (float,),  # noqa: E501
            'routing_number': (str,),  # noqa: E501
            'started_on': (str,),  # noqa: E501
            'subtype': (str,),  # noqa: E501
            'type': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'account_number': 'account_number',  # noqa: E501
        'apr': 'apr',  # noqa: E501
        'apy': 'apy',  # noqa: E501
        'available_balance': 'available_balance',  # noqa: E501
        'available_credit': 'available_credit',  # noqa: E501
        'balance': 'balance',  # noqa: E501
        'cash_surrender_value': 'cash_surrender_value',  # noqa: E501
        'credit_limit': 'credit_limit',  # noqa: E501
        'currency_code': 'currency_code',  # noqa: E501
        'day_payment_is_due': 'day_payment_is_due',  # noqa: E501
        'death_benefit': 'death_benefit',  # noqa: E501
        'id': 'id',  # noqa: E501
        'interest_rate': 'interest_rate',  # noqa: E501
        'is_closed': 'is_closed',  # noqa: E501
        'is_hidden': 'is_hidden',  # noqa: E501
        'last_payment': 'last_payment',  # noqa: E501
        'last_payment_at': 'last_payment_at',  # noqa: E501
        'loan_amount': 'loan_amount',  # noqa: E501
        'matures_on': 'matures_on',  # noqa: E501
        'metadata': 'metadata',  # noqa: E501
        'minimum_balance': 'minimum_balance',  # noqa: E501
        'minimum_payment': 'minimum_payment',  # noqa: E501
        'name': 'name',  # noqa: E501
        'nickname': 'nickname',  # noqa: E501
        'original_balance': 'original_balance',  # noqa: E501
        'payment_due_at': 'payment_due_at',  # noqa: E501
        'payoff_balance': 'payoff_balance',  # noqa: E501
        'routing_number': 'routing_number',  # noqa: E501
        'started_on': 'started_on',  # noqa: E501
        'subtype': 'subtype',  # noqa: E501
        'type': 'type',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """ManagedAccountUpdateRequest - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            account_number (str): [optional]  # noqa: E501
            apr (float): [optional]  # noqa: E501
            apy (float): [optional]  # noqa: E501
            available_balance (float): [optional]  # noqa: E501
            available_credit (float): [optional]  # noqa: E501
            balance (float): [optional]  # noqa: E501
            cash_surrender_value (float): [optional]  # noqa: E501
            credit_limit (float): [optional]  # noqa: E501
            currency_code (str): [optional]  # noqa: E501
            day_payment_is_due (int): [optional]  # noqa: E501
            death_benefit (int): [optional]  # noqa: E501
            id (str): [optional]  # noqa: E501
            interest_rate (float): [optional]  # noqa: E501
            is_closed (bool): [optional]  # noqa: E501
            is_hidden (bool): [optional]  # noqa: E501
            last_payment (float): [optional]  # noqa: E501
            last_payment_at (str): [optional]  # noqa: E501
            loan_amount (float): [optional]  # noqa: E501
            matures_on (str): [optional]  # noqa: E501
            metadata (str): [optional]  # noqa: E501
            minimum_balance (float): [optional]  # noqa: E501
            minimum_payment (float): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            nickname (str): [optional]  # noqa: E501
            original_balance (float): [optional]  # noqa: E501
            payment_due_at (str): [optional]  # noqa: E501
            payoff_balance (float): [optional]  # noqa: E501
            routing_number (str): [optional]  # noqa: E501
            started_on (str): [optional]  # noqa: E501
            subtype (str): [optional]  # noqa: E501
            type (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """ManagedAccountUpdateRequest - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            account_number (str): [optional]  # noqa: E501
            apr (float): [optional]  # noqa: E501
            apy (float): [optional]  # noqa: E501
            available_balance (float): [optional]  # noqa: E501
            available_credit (float): [optional]  # noqa: E501
            balance (float): [optional]  # noqa: E501
            cash_surrender_value (float): [optional]  # noqa: E501
            credit_limit (float): [optional]  # noqa: E501
            currency_code (str): [optional]  # noqa: E501
            day_payment_is_due (int): [optional]  # noqa: E501
            death_benefit (int): [optional]  # noqa: E501
            id (str): [optional]  # noqa: E501
            interest_rate (float): [optional]  # noqa: E501
            is_closed (bool): [optional]  # noqa: E501
            is_hidden (bool): [optional]  # noqa: E501
            last_payment (float): [optional]  # noqa: E501
            last_payment_at (str): [optional]  # noqa: E501
            loan_amount (float): [optional]  # noqa: E501
            matures_on (str): [optional]  # noqa: E501
            metadata (str): [optional]  # noqa: E501
            minimum_balance (float): [optional]  # noqa: E501
            minimum_payment (float): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            nickname (str): [optional]  # noqa: E501
            original_balance (float): [optional]  # noqa: E501
            payment_due_at (str): [optional]  # noqa: E501
            payoff_balance (float): [optional]  # noqa: E501
            routing_number (str): [optional]  # noqa: E501
            started_on (str): [optional]  # noqa: E501
            subtype (str): [optional]  # noqa: E501
            type (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
